
_ticker:

;Multitasking.c,88 :: 		void ticker()
;Multitasking.c,91 :: 		for(i=0; i<NTASKS; i++)
	CLRF       ticker_i_L0+0
	CLRF       ticker_i_L0+1
L_ticker0:
	MOVLW      128
	XORWF      ticker_i_L0+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ticker63
	MOVLW      8
	SUBWF      ticker_i_L0+0, 0
L__ticker63:
	BTFSC      STATUS+0, 0
	GOTO       L_ticker1
;Multitasking.c,93 :: 		if(tasks[i].tick > 0) tasks[i].tick--;
	MOVLW      6
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       ticker_i_L0+0, 0
	MOVWF      R4+0
	MOVF       ticker_i_L0+1, 0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVLW      _tasks+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ticker64
	MOVF       R1+0, 0
	SUBLW      0
L__ticker64:
	BTFSC      STATUS+0, 0
	GOTO       L_ticker3
	MOVLW      6
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       ticker_i_L0+0, 0
	MOVWF      R4+0
	MOVF       ticker_i_L0+1, 0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVLW      _tasks+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R0+1
	MOVLW      1
	SUBWF      R0+0, 1
	BTFSS      STATUS+0, 0
	DECF       R0+1, 1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       R0+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
L_ticker3:
;Multitasking.c,91 :: 		for(i=0; i<NTASKS; i++)
	INCF       ticker_i_L0+0, 1
	BTFSC      STATUS+0, 2
	INCF       ticker_i_L0+1, 1
;Multitasking.c,94 :: 		}
	GOTO       L_ticker0
L_ticker1:
;Multitasking.c,95 :: 		}
L_end_ticker:
	RETURN
; end of _ticker

_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;Multitasking.c,98 :: 		void interrupt() {
;Multitasking.c,99 :: 		if (TMR0IF_bit) {
	BTFSS      TMR0IF_bit+0, 2
	GOTO       L_interrupt4
;Multitasking.c,100 :: 		cnt++;                 // increment counter
	INCF       _cnt+0, 1
	BTFSC      STATUS+0, 2
	INCF       _cnt+1, 1
;Multitasking.c,101 :: 		TMR0IF_bit = 0;        // clear TMR0IF
	BCF        TMR0IF_bit+0, 2
;Multitasking.c,102 :: 		TMR0   = 96;
	MOVLW      96
	MOVWF      TMR0+0
;Multitasking.c,103 :: 		}
L_interrupt4:
;Multitasking.c,104 :: 		}
L_end_interrupt:
L__interrupt66:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_ftask0:

;Multitasking.c,106 :: 		void ftask0(struct task *pt)
;Multitasking.c,108 :: 		switch(pt->state){
	INCF       FARG_ftask0_pt+0, 0
	MOVWF      R3+0
	GOTO       L_ftask05
;Multitasking.c,109 :: 		case TICKING:
L_ftask07:
;Multitasking.c,110 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_ftask0_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ftask068
	MOVF       R1+0, 0
	SUBLW      0
L__ftask068:
	BTFSC      STATUS+0, 0
	GOTO       L_ftask08
	GOTO       L_ftask06
L_ftask08:
;Multitasking.c,111 :: 		else pt->state=TICKED;
	INCF       FARG_ftask0_pt+0, 0
	MOVWF      FSR
	MOVLW      5
	MOVWF      INDF+0
;Multitasking.c,112 :: 		case TICKED:
L_ftask010:
;Multitasking.c,114 :: 		bTask0=~bTask0;
	MOVLW      1
	XORWF      PORTB+0, 1
;Multitasking.c,115 :: 		pt->tick=pt->interval;
	MOVLW      2
	ADDWF      FARG_ftask0_pt+0, 0
	MOVWF      R2+0
	MOVLW      4
	ADDWF      FARG_ftask0_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R0+1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       R0+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,116 :: 		pt->state=TICKING;
	INCF       FARG_ftask0_pt+0, 0
	MOVWF      FSR
	MOVLW      4
	MOVWF      INDF+0
;Multitasking.c,117 :: 		break;
	GOTO       L_ftask06
;Multitasking.c,118 :: 		case IDLE:    break;
L_ftask011:
	GOTO       L_ftask06
;Multitasking.c,119 :: 		default:      break;
L_ftask012:
	GOTO       L_ftask06
;Multitasking.c,120 :: 		}
L_ftask05:
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_ftask07
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      5
	BTFSC      STATUS+0, 2
	GOTO       L_ftask010
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      10
	BTFSC      STATUS+0, 2
	GOTO       L_ftask011
	GOTO       L_ftask012
L_ftask06:
;Multitasking.c,121 :: 		}
L_end_ftask0:
	RETURN
; end of _ftask0

_ftask1:

;Multitasking.c,123 :: 		void ftask1(struct task *pt)
;Multitasking.c,125 :: 		switch(pt->state){
	INCF       FARG_ftask1_pt+0, 0
	MOVWF      R3+0
	GOTO       L_ftask113
;Multitasking.c,126 :: 		case TICKING:
L_ftask115:
;Multitasking.c,127 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_ftask1_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ftask170
	MOVF       R1+0, 0
	SUBLW      0
L__ftask170:
	BTFSC      STATUS+0, 0
	GOTO       L_ftask116
	GOTO       L_ftask114
L_ftask116:
;Multitasking.c,128 :: 		else pt->state=TICKED;
	INCF       FARG_ftask1_pt+0, 0
	MOVWF      FSR
	MOVLW      5
	MOVWF      INDF+0
;Multitasking.c,129 :: 		case TICKED:
L_ftask118:
;Multitasking.c,131 :: 		bTask1=~bTask1;
	MOVLW      2
	XORWF      PORTB+0, 1
;Multitasking.c,132 :: 		pt->tick=pt->interval;
	MOVLW      2
	ADDWF      FARG_ftask1_pt+0, 0
	MOVWF      R2+0
	MOVLW      4
	ADDWF      FARG_ftask1_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R0+1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       R0+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,133 :: 		pt->state=TICKING;
	INCF       FARG_ftask1_pt+0, 0
	MOVWF      FSR
	MOVLW      4
	MOVWF      INDF+0
;Multitasking.c,134 :: 		break;
	GOTO       L_ftask114
;Multitasking.c,135 :: 		case IDLE:    break;
L_ftask119:
	GOTO       L_ftask114
;Multitasking.c,136 :: 		default:      break;
L_ftask120:
	GOTO       L_ftask114
;Multitasking.c,137 :: 		}
L_ftask113:
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_ftask115
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      5
	BTFSC      STATUS+0, 2
	GOTO       L_ftask118
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      10
	BTFSC      STATUS+0, 2
	GOTO       L_ftask119
	GOTO       L_ftask120
L_ftask114:
;Multitasking.c,138 :: 		}
L_end_ftask1:
	RETURN
; end of _ftask1

_pwm:

;Multitasking.c,140 :: 		void pwm(struct task *pt)
;Multitasking.c,142 :: 		switch(pt->state){
	INCF       FARG_pwm_pt+0, 0
	MOVWF      R3+0
	GOTO       L_pwm21
;Multitasking.c,143 :: 		case ON:
L_pwm23:
;Multitasking.c,144 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_pwm_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__pwm72
	MOVF       R1+0, 0
	SUBLW      0
L__pwm72:
	BTFSC      STATUS+0, 0
	GOTO       L_pwm24
	GOTO       L_pwm22
L_pwm24:
;Multitasking.c,148 :: 		bPWM=1;
	BSF        PORTB+0, 2
;Multitasking.c,149 :: 		pt->tick=100;
	MOVLW      2
	ADDWF      FARG_pwm_pt+0, 0
	MOVWF      FSR
	MOVLW      100
	MOVWF      INDF+0
	MOVLW      0
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,150 :: 		pt->state=OFF;
	INCF       FARG_pwm_pt+0, 0
	MOVWF      FSR
	MOVLW      2
	MOVWF      INDF+0
;Multitasking.c,152 :: 		break;
	GOTO       L_pwm22
;Multitasking.c,153 :: 		case OFF:
L_pwm26:
;Multitasking.c,154 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_pwm_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__pwm73
	MOVF       R1+0, 0
	SUBLW      0
L__pwm73:
	BTFSC      STATUS+0, 0
	GOTO       L_pwm27
	GOTO       L_pwm22
L_pwm27:
;Multitasking.c,157 :: 		bPWM=0;
	BCF        PORTB+0, 2
;Multitasking.c,158 :: 		pt->tick=300;
	MOVLW      2
	ADDWF      FARG_pwm_pt+0, 0
	MOVWF      FSR
	MOVLW      44
	MOVWF      INDF+0
	MOVLW      1
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,159 :: 		pt->state=ON;
	INCF       FARG_pwm_pt+0, 0
	MOVWF      FSR
	MOVLW      3
	MOVWF      INDF+0
;Multitasking.c,161 :: 		case IDLE:    break;
L_pwm29:
	GOTO       L_pwm22
;Multitasking.c,162 :: 		default:      break;
L_pwm30:
	GOTO       L_pwm22
;Multitasking.c,163 :: 		}
L_pwm21:
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_pwm23
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_pwm26
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      10
	BTFSC      STATUS+0, 2
	GOTO       L_pwm29
	GOTO       L_pwm30
L_pwm22:
;Multitasking.c,164 :: 		}
L_end_pwm:
	RETURN
; end of _pwm

_traffic_lights:

;Multitasking.c,166 :: 		void traffic_lights(struct task *pt)
;Multitasking.c,168 :: 		switch(pt->state){
	INCF       FARG_traffic_lights_pt+0, 0
	MOVWF      R3+0
	GOTO       L_traffic_lights31
;Multitasking.c,169 :: 		case RED:
L_traffic_lights33:
;Multitasking.c,170 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__traffic_lights75
	MOVF       R1+0, 0
	SUBLW      0
L__traffic_lights75:
	BTFSC      STATUS+0, 0
	GOTO       L_traffic_lights34
	GOTO       L_traffic_lights32
L_traffic_lights34:
;Multitasking.c,173 :: 		bRed=1; bYellow=0;
	BSF        PORTB+0, 7
	BCF        PORTB+0, 6
;Multitasking.c,174 :: 		pt->tick=300;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      44
	MOVWF      INDF+0
	MOVLW      1
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,175 :: 		pt->state=REDYELLOW;
	INCF       FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      7
	MOVWF      INDF+0
;Multitasking.c,177 :: 		break;
	GOTO       L_traffic_lights32
;Multitasking.c,178 :: 		case REDYELLOW:
L_traffic_lights36:
;Multitasking.c,179 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__traffic_lights76
	MOVF       R1+0, 0
	SUBLW      0
L__traffic_lights76:
	BTFSC      STATUS+0, 0
	GOTO       L_traffic_lights37
	GOTO       L_traffic_lights32
L_traffic_lights37:
;Multitasking.c,182 :: 		bYellow=1;
	BSF        PORTB+0, 6
;Multitasking.c,183 :: 		pt->tick=100;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      100
	MOVWF      INDF+0
	MOVLW      0
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,184 :: 		pt->state=GREEN;
	INCF       FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      8
	MOVWF      INDF+0
;Multitasking.c,186 :: 		case GREEN:
L_traffic_lights39:
;Multitasking.c,187 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__traffic_lights77
	MOVF       R1+0, 0
	SUBLW      0
L__traffic_lights77:
	BTFSC      STATUS+0, 0
	GOTO       L_traffic_lights40
	GOTO       L_traffic_lights32
L_traffic_lights40:
;Multitasking.c,190 :: 		bRed=0; bYellow=0; bGreen=1;
	BCF        PORTB+0, 7
	BCF        PORTB+0, 6
	BSF        PORTB+0, 5
;Multitasking.c,191 :: 		pt->tick=300;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      44
	MOVWF      INDF+0
	MOVLW      1
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,192 :: 		pt->state=YELLOW;
	INCF       FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      9
	MOVWF      INDF+0
;Multitasking.c,194 :: 		break;
	GOTO       L_traffic_lights32
;Multitasking.c,195 :: 		case YELLOW:
L_traffic_lights42:
;Multitasking.c,196 :: 		if(pt->tick > 0) break;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R1+1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__traffic_lights78
	MOVF       R1+0, 0
	SUBLW      0
L__traffic_lights78:
	BTFSC      STATUS+0, 0
	GOTO       L_traffic_lights43
	GOTO       L_traffic_lights32
L_traffic_lights43:
;Multitasking.c,199 :: 		bGreen=0; bYellow=1;
	BCF        PORTB+0, 5
	BSF        PORTB+0, 6
;Multitasking.c,200 :: 		pt->tick=100;
	MOVLW      2
	ADDWF      FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      100
	MOVWF      INDF+0
	MOVLW      0
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,201 :: 		pt->state=RED;
	INCF       FARG_traffic_lights_pt+0, 0
	MOVWF      FSR
	MOVLW      6
	MOVWF      INDF+0
;Multitasking.c,203 :: 		break;
	GOTO       L_traffic_lights32
;Multitasking.c,204 :: 		case IDLE:    break;
L_traffic_lights45:
	GOTO       L_traffic_lights32
;Multitasking.c,205 :: 		default:      break;
L_traffic_lights46:
	GOTO       L_traffic_lights32
;Multitasking.c,206 :: 		}
L_traffic_lights31:
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      6
	BTFSC      STATUS+0, 2
	GOTO       L_traffic_lights33
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L_traffic_lights36
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L_traffic_lights39
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      9
	BTFSC      STATUS+0, 2
	GOTO       L_traffic_lights42
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      10
	BTFSC      STATUS+0, 2
	GOTO       L_traffic_lights45
	GOTO       L_traffic_lights46
L_traffic_lights32:
;Multitasking.c,207 :: 		}
L_end_traffic_lights:
	RETURN
; end of _traffic_lights

_port_poll:

;Multitasking.c,210 :: 		void port_poll(struct task *pt)
;Multitasking.c,212 :: 		switch(pt->state)
	INCF       FARG_port_poll_pt+0, 0
	MOVWF      R1+0
	GOTO       L_port_poll47
;Multitasking.c,214 :: 		case IDLE:
L_port_poll49:
;Multitasking.c,215 :: 		if(bSemStopOld==0 && bSemStop==1) {
	BTFSC      _PORTC_OLD+0, 0
	GOTO       L_port_poll52
	BTFSS      PORTC+0, 0
	GOTO       L_port_poll52
L__port_poll61:
;Multitasking.c,216 :: 		bRed=bYellow=bGreen=0;
	BCF        PORTB+0, 5
	BTFSC      PORTB+0, 5
	GOTO       L__port_poll80
	BCF        PORTB+0, 6
	GOTO       L__port_poll81
L__port_poll80:
	BSF        PORTB+0, 6
L__port_poll81:
	BTFSC      PORTB+0, 6
	GOTO       L__port_poll82
	BCF        PORTB+0, 7
	GOTO       L__port_poll83
L__port_poll82:
	BSF        PORTB+0, 7
L__port_poll83:
;Multitasking.c,217 :: 		tasks[2].tick=0;
	CLRF       _tasks+14
	CLRF       _tasks+15
;Multitasking.c,218 :: 		tasks[2].state=IDLE;
	MOVLW      10
	MOVWF      _tasks+13
;Multitasking.c,219 :: 		}
L_port_poll52:
;Multitasking.c,220 :: 		if(bSemStartOld==0 && bSemStart==1) {
	BTFSC      _PORTC_OLD+0, 1
	GOTO       L_port_poll55
	BTFSS      PORTC+0, 1
	GOTO       L_port_poll55
L__port_poll60:
;Multitasking.c,221 :: 		tasks[2].tick=tasks[2].interval;
	MOVF       _tasks+16, 0
	MOVWF      _tasks+14
	MOVF       _tasks+17, 0
	MOVWF      _tasks+15
;Multitasking.c,222 :: 		tasks[2].state=RED;
	MOVLW      6
	MOVWF      _tasks+13
;Multitasking.c,223 :: 		}
L_port_poll55:
;Multitasking.c,224 :: 		break;
	GOTO       L_port_poll48
;Multitasking.c,225 :: 		default: break;
L_port_poll56:
	GOTO       L_port_poll48
;Multitasking.c,226 :: 		}
L_port_poll47:
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      10
	BTFSC      STATUS+0, 2
	GOTO       L_port_poll49
	GOTO       L_port_poll56
L_port_poll48:
;Multitasking.c,227 :: 		}
L_end_port_poll:
	RETURN
; end of _port_poll

_task_init:

;Multitasking.c,229 :: 		void task_init(int i, int state, int tick, int counter)
;Multitasking.c,231 :: 		tasks[i].id=i;
	MOVLW      6
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       FARG_task_init_i+0, 0
	MOVWF      R4+0
	MOVF       FARG_task_init_i+1, 0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	ADDLW      _tasks+0
	MOVWF      FSR
	MOVF       FARG_task_init_i+0, 0
	MOVWF      INDF+0
;Multitasking.c,232 :: 		tasks[i].state=state;
	MOVLW      6
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       FARG_task_init_i+0, 0
	MOVWF      R4+0
	MOVF       FARG_task_init_i+1, 0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVLW      _tasks+0
	ADDWF      R0+0, 1
	INCF       R0+0, 0
	MOVWF      FSR
	MOVF       FARG_task_init_state+0, 0
	MOVWF      INDF+0
;Multitasking.c,233 :: 		tasks[i].tick=tick;
	MOVLW      6
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       FARG_task_init_i+0, 0
	MOVWF      R4+0
	MOVF       FARG_task_init_i+1, 0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVLW      _tasks+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       FARG_task_init_tick+0, 0
	MOVWF      INDF+0
	MOVF       FARG_task_init_tick+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,234 :: 		tasks[i].interval=tasks[i].tick;
	MOVLW      6
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       FARG_task_init_i+0, 0
	MOVWF      R4+0
	MOVF       FARG_task_init_i+1, 0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVLW      _tasks+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      R2+0
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	INCF       FSR, 1
	MOVF       INDF+0, 0
	MOVWF      R0+1
	MOVF       R2+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       R0+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
;Multitasking.c,235 :: 		}
L_end_task_init:
	RETURN
; end of _task_init

_bsp_init:

;Multitasking.c,238 :: 		void bsp_init(void)
;Multitasking.c,240 :: 		OPTION_REG = 0x84;       // Assign prescaler to TMR0
	MOVLW      132
	MOVWF      OPTION_REG+0
;Multitasking.c,241 :: 		ANSEL  = 0;              // Configure AN pins as digital
	CLRF       ANSEL+0
;Multitasking.c,242 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;Multitasking.c,243 :: 		C1ON_bit = 0;            // Disable comparators
	BCF        C1ON_bit+0, 7
;Multitasking.c,244 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, 7
;Multitasking.c,245 :: 		TRISB = 0;               // PORTB is output
	CLRF       TRISB+0
;Multitasking.c,246 :: 		PORTB = 0x00;            // Initialize PORTB
	CLRF       PORTB+0
;Multitasking.c,247 :: 		TRISC = 0x03;            // B0 and B1 of PORTC are inputs
	MOVLW      3
	MOVWF      TRISC+0
;Multitasking.c,248 :: 		TMR0  = 96;              // Timer0 initial value
	MOVLW      96
	MOVWF      TMR0+0
;Multitasking.c,249 :: 		INTCON = 0xA0;           // Enable TMRO interrupt
	MOVLW      160
	MOVWF      INTCON+0
;Multitasking.c,251 :: 		}
L_end_bsp_init:
	RETURN
; end of _bsp_init

_main:

;Multitasking.c,253 :: 		void main() {
;Multitasking.c,254 :: 		cnt = 0;                 // Initialize cnt
	CLRF       _cnt+0
	CLRF       _cnt+1
;Multitasking.c,255 :: 		bsp_init();              // BSP Init
	CALL       _bsp_init+0
;Multitasking.c,257 :: 		task_init(0, TICKING, 100, 0);
	CLRF       FARG_task_init_i+0
	CLRF       FARG_task_init_i+1
	MOVLW      4
	MOVWF      FARG_task_init_state+0
	CLRF       FARG_task_init_state+1
	MOVLW      100
	MOVWF      FARG_task_init_tick+0
	MOVLW      0
	MOVWF      FARG_task_init_tick+1
	CLRF       FARG_task_init_counter+0
	CLRF       FARG_task_init_counter+1
	CALL       _task_init+0
;Multitasking.c,258 :: 		task_init(1, TICKING, 200, 0);
	MOVLW      1
	MOVWF      FARG_task_init_i+0
	MOVLW      0
	MOVWF      FARG_task_init_i+1
	MOVLW      4
	MOVWF      FARG_task_init_state+0
	CLRF       FARG_task_init_state+1
	MOVLW      200
	MOVWF      FARG_task_init_tick+0
	CLRF       FARG_task_init_tick+1
	CLRF       FARG_task_init_counter+0
	CLRF       FARG_task_init_counter+1
	CALL       _task_init+0
;Multitasking.c,259 :: 		task_init(2, RED, 0, 0);
	MOVLW      2
	MOVWF      FARG_task_init_i+0
	MOVLW      0
	MOVWF      FARG_task_init_i+1
	MOVLW      6
	MOVWF      FARG_task_init_state+0
	CLRF       FARG_task_init_state+1
	CLRF       FARG_task_init_tick+0
	CLRF       FARG_task_init_tick+1
	CLRF       FARG_task_init_counter+0
	CLRF       FARG_task_init_counter+1
	CALL       _task_init+0
;Multitasking.c,260 :: 		task_init(3, OFF, 0, 0);
	MOVLW      3
	MOVWF      FARG_task_init_i+0
	MOVLW      0
	MOVWF      FARG_task_init_i+1
	MOVLW      2
	MOVWF      FARG_task_init_state+0
	CLRF       FARG_task_init_state+1
	CLRF       FARG_task_init_tick+0
	CLRF       FARG_task_init_tick+1
	CLRF       FARG_task_init_counter+0
	CLRF       FARG_task_init_counter+1
	CALL       _task_init+0
;Multitasking.c,261 :: 		task_init(4, IDLE, 10, 0);
	MOVLW      4
	MOVWF      FARG_task_init_i+0
	MOVLW      0
	MOVWF      FARG_task_init_i+1
	MOVLW      10
	MOVWF      FARG_task_init_state+0
	CLRF       FARG_task_init_state+1
	MOVLW      10
	MOVWF      FARG_task_init_tick+0
	MOVLW      0
	MOVWF      FARG_task_init_tick+1
	CLRF       FARG_task_init_counter+0
	CLRF       FARG_task_init_counter+1
	CALL       _task_init+0
;Multitasking.c,264 :: 		while(1) {
L_main57:
;Multitasking.c,265 :: 		ftask0(&tasks[0]);
	MOVLW      _tasks+0
	MOVWF      FARG_ftask0_pt+0
	CALL       _ftask0+0
;Multitasking.c,266 :: 		ftask1(&tasks[1]);
	MOVLW      _tasks+6
	MOVWF      FARG_ftask1_pt+0
	CALL       _ftask1+0
;Multitasking.c,267 :: 		traffic_lights(&tasks[2]);
	MOVLW      _tasks+12
	MOVWF      FARG_traffic_lights_pt+0
	CALL       _traffic_lights+0
;Multitasking.c,268 :: 		pwm(&tasks[3]);
	MOVLW      _tasks+18
	MOVWF      FARG_pwm_pt+0
	CALL       _pwm+0
;Multitasking.c,269 :: 		port_poll(&tasks[4]);
	MOVLW      _tasks+24
	MOVWF      FARG_port_poll_pt+0
	CALL       _port_poll+0
;Multitasking.c,270 :: 		if (cnt >= 4) {
	MOVLW      0
	SUBWF      _cnt+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main87
	MOVLW      4
	SUBWF      _cnt+0, 0
L__main87:
	BTFSS      STATUS+0, 0
	GOTO       L_main59
;Multitasking.c,271 :: 		ticker();
	CALL       _ticker+0
;Multitasking.c,272 :: 		cnt = 0;                       // Reset cnt
	CLRF       _cnt+0
	CLRF       _cnt+1
;Multitasking.c,273 :: 		memcpy(&PORTC_OLD, &PORTC, 1); // BSP
	MOVLW      _PORTC_OLD+0
	MOVWF      FARG_memcpy_d1+0
	MOVLW      PORTC+0
	MOVWF      FARG_memcpy_s1+0
	MOVLW      1
	MOVWF      FARG_memcpy_n+0
	MOVLW      0
	MOVWF      FARG_memcpy_n+1
	CALL       _memcpy+0
;Multitasking.c,274 :: 		}
L_main59:
;Multitasking.c,278 :: 		} // Endless loop
	GOTO       L_main57
;Multitasking.c,279 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
